rng shuffle

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Variable Initilization

%Initialize Devices Communication
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initialize serial port
myComPort = serialport(COM_PORT_NUMBER,BAUD_RATE);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create result cell array for the following columns

% Below you will define:
% col 1 : Key used for MATLAB (and attack platform) computation of the AES in hex format
% col 2 : random plaintext generated by MATLAB  in hex format
% col 3 : Verification ciphertext (only for the first computation) in hex format
% col 4 : Ciphertext as computed by the STM32 in hex format

result = {};

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Execution
% For all traces in dataset
for enc_num = 1:numofencryptions

    plaintexts_SCA(enc_num,:) = plaintext.'; %for SCA algorithm

    % Pause for 10 ns
    %pause(0.001);

    write_plaintext;

    %Save data in result matrix - hexadecimal form
    p = dec2hex(plaintext.');

    c = dec2hex(ciphertext.');

    result{enc_num,1} = cell2mat(key_hex);

temp = '';
    for t=1:plaintext_length
        temp = strcat(temp,p(t,:));
    end
    result{enc_num,2} = temp;

    temp = '';
    for t=1:ciphertext_length
        temp = strcat(temp,c(t,:));
    end
    result{enc_num,4} = temp;

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Verify Cipher from Matlab - only for the first ciphertext

    if (VERIF == 1)

        if(ENC_ID == "AES")
            % Initialization - AES scipt are defined in ./utils/AES folder
            [s_box, inv_s_box, w, poly_mat, inv_poly_mat] = aes_init(key_hex);

            % Encrypt the plaintext to ciphertext through Matlab
            ciphertext = cipher (plaintext, w, s_box, poly_mat,1).';
            c = dec2hex(ciphertext);
            temp = '';
            for t=1:ciphertext_length
                temp = strcat(temp,c(t,:));
            end
            result{enc_num,3} = temp;
        end

        %% Error if MATLAB ciphertext does not correspond to NUCLEO

        if(strcmp(result{enc_num,3},result{enc_num,4}) == 0)
            error ('Error : Encryption verification failed')
        end
    end
    
    clear plaintexts_SCA result;


    % New plaintext generation
    random_plaintext_bin = num2str(randi(2,1,(plaintext_length*8))-1);
    random_plaintext_bin(strfind(random_plaintext_bin,' ')) = [];
    byte_split = reshape(random_plaintext_bin,plaintext_length,8);
    for i = 1:plaintext_length
        plaintext(i) = bin2dec(byte_split(i,:));
    end
    plaintext = plaintext.';

    %%%
end